import type { Config, RecComponent } from '~/components/pub/my-ui/data-table'
import { defineAsyncComponent } from 'vue'

type SmallDetailDto = any

const action = defineAsyncComponent(() => import('~/components/pub/my-ui/data/dropdown-action-dud.vue'))
const statusBadge = defineAsyncComponent(() => import('./status-badge.vue'))

const _doctorStatus = {
  0: 'Tidak Aktif',
  1: 'Aktif',
}

export const config: Config = {
  cols: [
    { width: 100 },
    { width: 250 },
    {},
    { width: 100 },
    { width: 100 },
    {},
    {},
    {},
    { width: 120 },
    { width: 100 },
    {},
    {},
  ],

  headers: [
    [
      { label: 'Kode JKN' },
      { label: 'Nama' },
      { label: 'No KTP' },
      { label: 'No SIP' },
      { label: 'No IHS' },
      { label: 'Telpon' },
      { label: 'Fee Ranap' },
      { label: 'Fee Rajal' },
      { label: 'Status' },
      { label: '' },
    ],
  ],

  keys: [
    'bpjs_code',
    'name',
    'identity_number',
    'sip_no',
    'ihs_number',
    'phone',
    'inPatient_itemPrice',
    'outPatient_itemPrice',
    'status',
    'action',
  ],

  delKeyNames: [
    { key: 'code', label: 'Kode' },
    { key: 'name', label: 'Nama' },
  ],

  parses: {
    name: (rec: unknown): unknown => {
      const recX = rec as SmallDetailDto
      return `${recX.frontTitle} ${recX.name}  ${recX.endTitle}`.trim()
    },
    identity_number: (rec: unknown): unknown => {
      const recX = rec as SmallDetailDto
      if (recX.identity_number?.substring(0, 5) === 'BLANK') {
        return '(TANPA NIK)'
      }
      return recX.identity_number
    },
    inPatient_itemPrice: (rec: unknown): unknown => {
      const recX = rec as SmallDetailDto
      return Number(recX.inPatient_itemPrice.price).toLocaleString('id-ID')
    },
    outPatient_itemPrice: (rec: unknown): unknown => {
      const recX = rec as SmallDetailDto
      return Number(recX.outPatient_itemPrice.price).toLocaleString('id-ID')
    },
  },

  components: {
    action(rec, idx) {
      const res: RecComponent = {
        idx,
        rec: rec as object,
        component: action,
      }
      return res
    },
    status(rec, idx) {
      const res: RecComponent = {
        idx,
        rec: rec as object,
        component: statusBadge,
      }
      return res
    },
  },

  htmls: {
    patient_address(_rec) {
      return '-'
    },
  },
}
